<?php
/**
 * @category   Country
 * @package    Country_Custom
 * @author     shashank.bluethink@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Country\Custom\Setup;

use Magento\Framework\Setup\UpgradeDataInterface;
use \Magento\Framework\Setup\ModuleDataSetupInterface;
use \Magento\Framework\Setup\ModuleContextInterface;
use Magento\Directory\Model\RegionFactory;

class UpgradeData implements UpgradeDataInterface{

    public function __construct(

       RegionFactory $regionFactory
    )

    {
        $this->regionFactory = $regionFactory;
    }

    public function upgrade(ModuleDataSetupInterface $setup, ModuleContextInterface $context)
    {
         $this->setup = $setup;

       if (version_compare($context->getVersion(), '1.0.7', '<')) {
            $this->addUAEReagion();
        }
    }

    public function addUAEReagion()
    {
       
        $regionId = 1;
        $regions = [
            ['code' => 'AUH' . $regionId++, 'name' => 'Abu Dhabi'],
            ['code' => 'DXB' . $regionId++, 'name' => 'Dubai'],
            ['code' => 'SHJ' . $regionId++, 'name' => 'Sharjah'],
         ];
           $this->_addRegions($regions, 'AE');
    }

    public function _addRegions($regions)
    {

        foreach ($regions as $region) {
            $model = $this->regionFactory->create();

            $model->setCountryId('AE');
            $model->setCode($region['code']);
            $model->setDefaultName($region['name']);

            $model->getResource()->save($model);
        }
    }

}